<?php

namespace Teknisa\CRM\Controller;

use Doctrine\ORM\Query\Expr\Func;
use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\Util\Functions;
use Teknisa\CRM\Service\MauticService;

class crm00002007InterlocutorController extends TeknisaCrud
{

    protected $mauticService;
    protected $dataSourceName = 'crm_interlocutor';
    protected $parameterBagColumns = array('NRORG', 'P_NRORGPADRAO');

    public function __construct($crudService, $parameterBag, MauticService $mauticService)
    {
        $this->mauticService = $mauticService;
        parent::__construct($crudService, $parameterBag);
    }

    public function findInterlocParc(Request $request, Response $response)
    {
        $this->dataSourceName = 'crm_interlocutor_parcnegocio';
        parent::find($request, $response);
    }

    public function save(Request $request, Response $response)
    {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['IDATIVO'] = 'S';
            if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRSEQINTERLOCUTOR', $row)) {
                if ($row['__is_new']) {
                    $row['NRSEQINTERLOCUTOR'] = NovoCodigo::geraCodigo($row['NRORGINCLUSAO'], "CRM_INTERLOCUTOR", 1, 10, false, true);
                }
            } else {
                $row['NRSEQINTERLOCUTOR'] = NovoCodigo::geraCodigo($row['NRORGINCLUSAO'], "CRM_INTERLOCUTOR", 1, 10, false, true);
            }

            if (isset($row['__is_new']) && $row['__is_new']) {
                $idMautic = $this->mauticService->createContact($row);
                $row['IDMAUTIC'] = $idMautic;
            } else {
                $this->mauticService->editContact($row);
            }

            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function remove(Request $request, Response $response)
    {       
        try {
            $row = $request->getRow();          
            $row['IDATIVO'] = 'N';

            $this->mauticService->editContact($row);

            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
