<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class MauticFactory
{
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    public function getParams()
    {
        $select = "SELECT DSPUBLICKEYMAUTIC, DSSECRETKEYMAUTIC, DSBASEURLMAUTIC
                   FROM CRM_PARAMETRIZACAO";

        try{
            return $this->connection->query($select)->fetch();
        }
        catch(\Exception $e){
            throw $e;
        };
    }

    public function saveParamMautic($params) {

        $sql = 'UPDATE CRM_PARAMETRIZACAO
                SET DSPUBLICKEYMAUTIC = :DSPUBLICKEYMAUTIC,
                    DSSECRETKEYMAUTIC = :DSSECRETKEYMAUTIC,
                    DSBASEURLMAUTIC   = :DSBASEURLMAUTIC,
                    MAUTICAUTH        = :MAUTICAUTH,
                    DTULTATU          = SYSDATE,
                    CDOPERULTATU      = :CDOPERADOR,
                    NRORGULTATU       = :NRORGOPER
                WHERE NRORG           = :NRORG';
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function getCompanyName($nrparceiro)
    {        
        try{
            $select = "SELECT NMPRINCIPALPARC
                       FROM PARCNEGOCIO
                       WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";
            
            $std = $this->connection->prepare($select);

            $params = array(
                "NRPARCNEGOCIO" => $nrparceiro
            );
            $std->execute($params);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }

    public function getCompanyNr($nmparceiro)
    {        
        try{
            $select = "SELECT NRPARCNEGOCIO
                       FROM PARCNEGOCIO
                       WHERE NMPRINCIPALPARC = :nmparceiro";
            
            $std = $this->connection->prepare($select);

            $params = array(
                "NRPARCNEGOCIO" => $nmparceiro
            );
            $std->execute($params);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }

    public function novoInterlocutor()
    {
        $insert = "INSERT INTO ";
    }



    public function novoParcnegocio($row)
    {
        try {            
            $insert = "INSERT INTO PARCNEGOCIO (IDINSTITUICAO, IDPARCFUNDIDO, CDTIPOINSCRICAO, CDTIPOPARCPRINCIPAL, NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, IDATIVO, DTINCLUSAO, NRORGINCLUSAO)
                        VALUES (:IDINSTITUICAO,
                                :IDPARCFUNDIDO,
                                :CDTIPOINSCRICAO,
                                :CDTIPOPARCPRINCIPAL,
                                :NRPARCNEGOCIO,
                                :NRORG,
                                :NMPRINCIPALPARC,
                                :NMSECUNDARIPARC,
                                :IDATIVO,
                                SYSDATE,
                                :NRORGINCLUSAO)";

            $params = array(
                "IDINSTITUICAO"         => 'S',
                "IDPARCFUNDIDO"         => 'N',
                "CDTIPOINSCRICAO"       => 'LIVRE',
                "CDTIPOPARCPRINCIPAL"   => 'CANDIDATO',
                "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
                "NRORG"                 => $row["NRORG"],
                "NMPRINCIPALPARC"       => $row["NMPRINCIPALPARC"],
                "NMSECUNDARIPARC"       => $row["NMPRINCIPALPARC"],
                "IDATIVO"               => $row["IDATIVO"],
                "NRORGINCLUSAO"         => $row["NRORG"],
            );

            $std = $this->connection->prepare($insert);
            $std->execute($params);

        } catch (\Exception $e) {
            throw $e;
        };
    }

    public function insertLead($row)
    {
        try {            
            $insert = "INSERT INTO CRM_CANDIDATO
                        (IDATIVO, DTINCLUSAO, NRCANDIDATO, IDSTATUSCAN, IDTPIJURCAN, NMCANDIDATO, NMFANTCAN, NRPARCNEGOCIO, NRORG,  DTULTATU, NRORGINCLUSAO, IDPARCFUNDIDO)
                        VALUES (:IDATIVO,
                                SYSDATE,
                                :NRCANDIDATO,
                                :IDSTATUSCAN,
                                :IDTPIJURCAN,
                                :NMCANDIDATO,
                                :NMFANTCAN,
                                :NRPARCNEGOCIO,
                                :NRORG,                                
                                SYSDATE,
                                :NRORGINCLUSAO,
                                :IDPARCFUNDIDO)";

            $params = array(
                "IDATIVO"                   => $row["IDATIVO"],
                "NRCANDIDATO"               => $row["NRCANDIDATO"],
                "IDSTATUSCAN"               => $row["IDSTATUSCAN"],
                "IDTPIJURCAN"               => $row["IDTPIJURCAN"],
                "NMCANDIDATO"               => $row["NMCANDIDATO"],
                "NMFANTCAN"                 => $row["NMFANTCAN"],
                "NRPARCNEGOCIO"             => $row["NRPARCNEGOCIO"],
                "NRORG"                     => $row["NRORG"],
                "NRORGINCLUSAO"             => $row["NRORGINCLUSAO"],
                "IDPARCFUNDIDO"             => $row["IDPARCFUNDIDO"],
            );

            $std = $this->connection->prepare($insert);
            $std->execute($params);

        } catch (\Exception $e) {
            throw $e;
        };
    } 

    public function insertStatusParc($params)
    {
        try {
            $insert =  "INSERT INTO 
                        CRM_STATUSPARC(NRPARCNEGOCIO,
                                       STATUSPARC,
                                       NRORG,
                                       CRM_NRORGTRAB,
                                       IDATIVO,
                                       DTINCLUSAO,
                                       DTULTATU)
                        VALUES (:NRPARCNEGOCIO,
                                :STATUSPARC,
                                :NRORG,
                                :CRM_NRORGTRAB,
                                :IDATIVO,
                                SYSDATE,
                                SYSDATE)";

            if (empty($params)) {
                $params = array(
                    "NRPARCNEGOCIO"         => $params["NRPARCNEGOCIO"],
                    "STATUSPARC"            => $params["STATUSPARC"],
                    "NRORG"                 => $params["NRORG"],
                    "CRM_NRORGTRAB"         => $params["CRM_NRORGTRAB"],
                    "IDATIVO"               => $params["IDATIVO"]
                );
            }

            $std = $this->connection->prepare($insert);
            $std->execute($params);
            return true;
        } catch (\Exception $e) {
            throw $e;
        };
    }
    

    public function verifyProspectName($params)
    {
        if (!empty($params['NMPRINCIPALPARC'])) {
            $select =  "SELECT  PARC.NRPARCNEGOCIO,
                                PARC.NMPRINCIPALPARC
                            FROM PARCNEGOCIO PARC
                        WHERE UPPER(PARC.NMPRINCIPALPARC) LIKE UPPER(:NOME)
                                AND PARC.NRORG = :NRORG";

            try {
                $stmt = $this->connection->prepare($select);

                $stmt->bindValue(':NOME', '%' . $params['NMPRINCIPALPARC'] . '%');
                $stmt->bindValue(':NRORG', $params['NRORG']);

                $stmt->execute();
                $lead = $stmt->fetchAll();

                return $lead;
                
            } catch (\Exception $e) {
                throw $e;
            }
        } else {
            return array();
        }
    }

    public function insertInterlocutor($params)
    {
        try {
            $insert =  "INSERT INTO 
                        CRM_INTERLOCUTOR ()
                        VALUES ()";

            if (empty($params)) {
                $params = array(
                    "NRPARCNEGOCIO"         => $params["NRPARCNEGOCIO"],
                    "STATUSPARC"            => $params["STATUSPARC"],
                    "NRORG"                 => $params["NRORG"],
                    "CRM_NRORGTRAB"         => $params["CRM_NRORGTRAB"],
                    "IDATIVO"               => $params["IDATIVO"]
                );
            }

            $std = $this->connection->prepare($insert);
            $std->execute($params);
            return true;
        } catch (\Exception $e) {
            throw $e;
        };
    }

    public function updateParcnegocio($fields, $params)
    {
        try {
            $fieldsToUpdate = [];

            foreach(array_keys($fields) as $key){
                $fieldsToUpdate[] = $key.' = :'.$key;  
            }
            $fieldsToUpdate  = implode(', ', $fieldsToUpdate);

            $update = "UPDATE 
                            PARCNEGOCIO
                        SET ".$fieldsToUpdate."                            
                        WHERE 
                            NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG";

            $params = array_merge($fields, $params);

            $std = $this->connection->prepare($update);
            $std->execute($params);

        } catch (\Exception $e) {
            throw $e;
        }

    }




/* 
    // Inserir um novo lead
    public function insert($params)
    {
        $insert = "INSERT INTO PARCNEGOCIO (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,IDPESSOAFISICA)
         VALUES (:NRPARCNEGOCIO,
                 :NRORG,
                 :NMPRINCIPALPARC,
                 :NMSECUNDARIPARC,
                 :NRINSCRICAOPARC,
                 :IDATIVO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDTIPOPARCPRINCIPAL,
                 :CDTIPOINSCRICAO,
                 :IDPESSOAFISICA)";

        $params = array(
            "IDATIVO"               => $row["IDATIVO"],
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
            "NRORG"                 => $row["NRORG"],
            "NMPRINCIPALPARC"       => $row["NMCANDIDATO"],
            "NMSECUNDARIPARC"       => $row["NMFANTCAN"],
            "NRINSCRICAOPARC"       => $row["NRINSJURCAN"],
            "NRORGINCLUSAO"         => $row["NRORG"],
            "CDOPERINCLUSAO"        => $row["CDOPEREVOL"],
            "CDTIPOPARCPRINCIPAL"   => "CANDIDATO",
            "CDTIPOINSCRICAO"       => $row["TIPOINSC"],
            "IDPESSOAFISICA"        => $row["ISCPF"],
        );

        try {
            $stmt = $this->connection->prepare($insert);
            $stmt->execute($params);
            return ['id' => $this->connection->lastInsertId(), 'name' => $params['name'], 'email' => $params['email']];
        } catch (\Exception $e) {
            throw $e;
        };   
    } */
}

